<template>
  <div>
    <div v-show="!searchRunning">
      <b-list-group>
        <b-button-group
          v-for="applicationProfile in applicationProfiles"
          :key="applicationProfile.base_url"
          v-b-tooltip.hover.noninteractive.top="{
            customClass: 'apTooltip',
            title: applicationProfile.description
              ? `${applicationProfile.description} (${applicationProfile.base_url})`
              : applicationProfile.base_url,
          }"
        >
          <b-row class="w-100 apRow">
            <b-col class="apCol">
              <b-list-group-item
                :id="applicationProfile.base_url.replace(/[\/.#:]/g, '')"
                button
                class="d-flex justify-content-between align-items-center"
                :name="applicationProfile.name"
                :active="
                  selectedApplicationProfile &&
                  selectedApplicationProfile.base_url ===
                    applicationProfile.base_url
                "
                @click="selectApplicationProfile(applicationProfile)"
              >
                {{ applicationProfile.name }}
                <div>
                  <b-badge
                    v-for="approvedBy in applicationProfile.approvedBy ?? []"
                    :key="approvedBy"
                    class="ms-1"
                    variant="info"
                    pill
                    >{{ approvedBy }}</b-badge
                  >
                </div>
              </b-list-group-item>
              <button
                v-if="applicationProfile.state === draftState"
                class="list-group-item btn-danger"
                @click="triggerRemoveDraftModal(applicationProfile)"
              >
                x
              </button>
            </b-col>
          </b-row>
        </b-button-group>
      </b-list-group>
      <div v-if="applicationProfiles.length === 0" class="grayed">
        <p>{{ $t("emptyApplicationProfileList") }}</p>
      </div>
    </div>
    <ListGroupSkeletons v-show="searchRunning" />
    <RemoveDraftModal
      :name="toBeRemovedDraft ? toBeRemovedDraft.name : 'AP'"
      :open="removeDraftModalOpen"
      @close="removeDraftModalOpen = false"
      @save="removeDraft"
    />
  </div>
</template>

<script lang="ts">
import { ApplicationProfile } from "@/types/application-profile";
import State from "@/types/state";

import { defineComponent, type PropType } from "vue";

import { useMainStore } from "@/store";

export default defineComponent({
  name: "ListAPs",
  props: {
    applicationProfiles: {
      required: true,
      type: Array as PropType<ApplicationProfile[]>,
    },
    searchRunning: {
      default: false,
      type: Boolean,
    },
    selectedApplicationProfile: {
      required: false,
      default: undefined,
      type: Object as PropType<ApplicationProfile | undefined>,
    },
  },
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      draftState: State.DRAFT,
      removeDraftModalOpen: false,
      toBeRemovedDraft: null as null | ApplicationProfile,
    };
  },
  methods: {
    removeDraft() {
      this.removeDraftModalOpen = false;
      if (this.toBeRemovedDraft) {
        this.mainStore.removeApplicationProfile(this.toBeRemovedDraft);
        this.toBeRemovedDraft = null;
        this.$emit("emptyApplicationProfile");
      }
    },
    selectApplicationProfile(applicationProfile: ApplicationProfile) {
      this.$emit("selectApplicationProfile", applicationProfile);
    },
    triggerRemoveDraftModal(toBeRemovedDraft: ApplicationProfile) {
      this.toBeRemovedDraft = toBeRemovedDraft;
      this.removeDraftModalOpen = true;
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.apRow {
  margin: 0px;
}
.apCol {
  display: flex;
  justify-content: flex-end;
  padding: 0px;
}
.grayed {
  color: gray;
}
</style>
